// Watch.cpp : Implementation of CWatch
#include "stdafx.h"
#include "FileMonitor.h"
#include "Watch.h"

#include <algorithm>
/////////////////////////////////////////////////////////////////////////////
// CWatch

DWORD WINAPI ThreadFunc(LPVOID lpParam);

STDMETHODIMP CWatch::AddPath(BSTR sPathName)
{
	// TODO: Add your implementation code here
	USES_CONVERSION;
	_bstr_t sNewPath(sPathName, false);
	deqString::iterator it = std::find(m_Paths.begin(), m_Paths.end(), OLE2T(sPathName));
	if ( it == m_Paths.end() )
	{
		bool bWatching = m_bStarted;
		if ( bWatching )
			stop();
		m_Paths.push_back(OLE2T(sNewPath));
		if ( bWatching )
			start();
	}
	return S_OK;
}

STDMETHODIMP CWatch::get_Start(VARIANT_BOOL *pVal)
{
	// TODO: Add your implementation code here

	*pVal = ( m_bStarted ) ? VARIANT_TRUE : VARIANT_FALSE;
	return S_OK;
}

STDMETHODIMP CWatch::put_Start(VARIANT_BOOL newVal)
{
	// TODO: Add your implementation code here

	if ( newVal == VARIANT_TRUE )	// Start the Watch
		start();
	else	// Stop the Watch
		stop();
	return S_OK;
}

STDMETHODIMP CWatch::RemovePath(BSTR sPathName)
{
	// TODO: Add your implementation code here
	USES_CONVERSION;
	deqString::iterator it = std::find(m_Paths.begin(), m_Paths.end(), OLE2T(sPathName));
	if ( it != m_Paths.end() )
	{
		bool bWatching = m_bStarted;
		if ( bWatching )
			stop();
		m_Paths.erase(it);
		if ( bWatching )
			start();
	}

	return S_OK;
}

void CWatch::start()
{
	if ( ! m_bStarted )
	{
		if ( m_hEvent == NULL )	// Create the event
		{
			m_hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
			if ( m_hEvent == NULL )
			{
				MessageBox(TEXT("Unable to create event"), TEXT("Start Property"), MB_OK);
				return;
			}
		}
		else
			ResetEvent(m_hEvent);
		m_hThread = CreateThread(NULL, 0, ThreadFunc, (LPVOID) this, 0, &m_dwThreadId);
		if ( m_hThread == NULL )
		{
			MessageBox(TEXT("Unable to create thread"), TEXT("Start Property"), MB_OK);
			return;
		}
		m_bStarted = true;
	}
}

void CWatch::stop()
{
	if ( m_bStarted )
	{
		if ( m_hEvent != NULL )
		{
			SetEvent(m_hEvent);
			if ( m_hThread != NULL )
			{
				CloseHandle(m_hThread);
				m_hThread = NULL;
			}
			m_bStarted = false;
		}
	}
}

DWORD WINAPI ThreadFunc(LPVOID lpParam)
{
	CWatch *pWatch = (CWatch *) lpParam;

	HANDLE *hHandles = new HANDLE[pWatch->m_Paths.size() * 2 + 1];
	while(1) // Endless loop
	{
		int i = 1;
		hHandles[0] = pWatch->m_hEvent;
		for(deqString::iterator it = pWatch->m_Paths.begin(); it != pWatch->m_Paths.end(); it++)
		{
			hHandles[i] = FindFirstChangeNotification((LPCTSTR) (*it).c_str(), FALSE, 
														FILE_NOTIFY_CHANGE_LAST_WRITE
														| FILE_NOTIFY_CHANGE_FILE_NAME);
			hHandles[i + 1] = FindFirstChangeNotification((LPCTSTR) (*it).c_str(), FALSE,
														FILE_NOTIFY_CHANGE_DIR_NAME);
			i += 2;
		}
		DWORD dwResult = WaitForMultipleObjects(pWatch->m_Paths.size() * 2 + 1, hHandles, FALSE, INFINITE);
		if ( dwResult == WAIT_OBJECT_0 )	// Watch stopped
			break;

		int nType = 0;
		i = dwResult - WAIT_OBJECT_0;
		if ( (i % 2) == 0 )	// DIR_CHANGE
			i = (i - 2) / 2;
		else			// FILE_CHANGE
		{
			i = (i - 1) / 2;
			nType = 1;
		}
		pWatch->m_sNotify = pWatch->m_Paths[i];
		pWatch->PostMessage(WM_WATCH_NOTIFY, nType, 0);
	}
	delete[] hHandles;
	return 0;
}
