/*
Date   : 19-01-2000											
Author : Franky Braem	(frankysprog@yucom.be)				
																
License : You're free to use these files in your projects    
          please let me know if you find this usefull.
          
		  For commercial programs : please at a the following 
          copyright in your info :
			"(c) FileMonitor Control created by Franky Braem (frankysprog@yucom.be)"
Updates : Check my website for updates www.braem17.yucom.be

29-01-2000 : changed the BOOL parameters to VARIANT_BOOL. 
29-02-2000 : made it Unicode compatible
*/

// Watch.h : Declaration of the CWatch

#ifndef __WATCH_H_
#define __WATCH_H_

#include <atlwin.h>
#include "resource.h"       // main symbols
#include "comdef.h"

#include <deque>
#include <string>
#include "FileMonitorCP.h"

#ifdef _UNICODE
	typedef std::wstring cstring;
#else
	typedef std::string cstring;
#endif
typedef std::deque<cstring> deqString;

#define WM_WATCH_NOTIFY	(WM_USER + 101)

/////////////////////////////////////////////////////////////////////////////
// CWatch
class ATL_NO_VTABLE CWatch : 
	public CWindowImpl<CWatch>,
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CWatch, &CLSID_Watch>,
	public IConnectionPointContainerImpl<CWatch>,
	public IDispatchImpl<IWatch, &IID_IWatch, &LIBID_FILEMONITOR>,
	public CProxy_IWatchEvents< CWatch >
{
public:
	CWatch()
	{
		m_bStarted = false;
		m_hEvent = NULL;
		m_hThread = NULL;
	}
	deqString m_Paths;
	HANDLE m_hEvent;
	HANDLE m_hThread;
	DWORD m_dwThreadId;
	bool m_bStarted;
	cstring m_sNotify;

DECLARE_WND_CLASS(TEXT("Watch"))
BEGIN_MSG_MAP(CWatch)
	MESSAGE_HANDLER(WM_WATCH_NOTIFY, OnWatchNotify)
END_MSG_MAP()

	LRESULT OnWatchNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
	{
		Fire_Notify(_bstr_t(m_sNotify.c_str()), wParam);
		return 0;
	}
	HRESULT FinalConstruct()
	{
		RECT rect;
		rect.left = 0;
		rect.right = 100;
		rect.top = 0;
		rect.bottom = 100;
		HWND hwnd = Create(NULL, rect, TEXT("WatchWindow"), WS_POPUP);
		if ( hwnd ) 
			return S_OK;
		else
			return HRESULT_FROM_WIN32(GetLastError());
	}
	void FinalRelease()
	{
		if ( m_bStarted )
			stop();
		if ( m_hWnd != NULL )
			DestroyWindow();
	}
DECLARE_REGISTRY_RESOURCEID(IDR_WATCH)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWatch)
	COM_INTERFACE_ENTRY(IWatch)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CWatch)
CONNECTION_POINT_ENTRY(DIID__IWatchEvents)
END_CONNECTION_POINT_MAP()


// IWatch
public:
	STDMETHOD(RemovePath)(/*[in]*/ BSTR sPathName);
	STDMETHOD(get_Start)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_Start)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(AddPath)(/*[in]*/ BSTR sPathName);
private:
	void stop();
	void start();
};

#endif //__WATCH_H_
